#include <windows.h>
#include <commctrl.h>
#include <commdlg.h>
#include "ChgShell.h"
#include "resource.h"

#define _BE500	1
#ifndef _BE500
#if _WIN32_WCE > 299
#define _WIN32_WCE_PPC	1
#endif
#endif

//-------------------------------------------
//t@C݂̑mF
//-------------------------------------------
BOOL AccessFile (TCHAR* cFileName)
{
	HANDLE ff;
	WIN32_FIND_DATA wfd;

	//t@C
	ff = FindFirstFile (cFileName, &wfd);
	if (ff == INVALID_HANDLE_VALUE)
		return FALSE;
	FindClose (ff);

	//Program Diskȉɂ邩
	if (_wcsnicmp (cFileName, _T("\\Program Disk\\"),14) != 0)
		return FALSE;

	return TRUE;
}

//-------------------------------------------
//WXglo
//-------------------------------------------
int GetRegValue (TCHAR* key, TCHAR* dat)
{
	HKEY hKey;
	DWORD dwType;
	TCHAR buf[MAX_PATH];
	DWORD len;
	long rc;

	dat[0] = 0;

	rc = RegOpenKeyEx (HKEY_LOCAL_MACHINE, key, 0, KEY_QUERY_VALUE, &hKey);
	if (rc != ERROR_SUCCESS)
		return FALSE;

	len = sizeof(buf)/sizeof(TCHAR) - 1;
	rc = RegQueryValueEx(hKey, TEXT("File"), NULL, &dwType, (LPBYTE)buf, &len);
	if (rc == ERROR_SUCCESS) {
		lstrcpy (dat, buf);
	}

	RegCloseKey(hKey);
	return TRUE;
}

//-------------------------------------------
//WXg֒l
//-------------------------------------------
int SetRegValue (TCHAR* key, TCHAR* dat)
{
	HKEY hKey = NULL;
	long rc;
	DWORD dwDisposition;

	rc = RegCreateKeyEx (HKEY_LOCAL_MACHINE, key, 0, TEXT(""), 
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition);
	if (rc != ERROR_SUCCESS) {
		return FALSE;
	}

	RegSetValueEx(hKey, TEXT("File"), 0, REG_SZ, (LPBYTE)dat, 
		sizeof(TCHAR) * (wcslen(dat)+1));

	RegCloseKey(hKey);
	return TRUE;
}

//-------------------------------------------
//t@C_CAO\
//-------------------------------------------
BOOL GetFileName (HWND hWnd, TCHAR *ret, TCHAR *DefExt, BOOL OpenSave)
{
	OPENFILENAME of;
	TCHAR path[MAX_PATH];

#define STR_FILE_FILTER				TEXT("exȩ (*.exe)\0*.exe\0ׂĂ̧ (*.*)\0*.*\0\0")
#define STR_TITLE_OPEN				TEXT("J")
#define STR_TITLE_SAVE				TEXT("ۑ")

	//t@Cɕۑ
	lstrcpy(path, ret);
	memset (&of, 0, sizeof(OPENFILENAME));
	of.lStructSize  = sizeof(OPENFILENAME);
	of.hInstance    = g_hInstance;
	of.hwndOwner    = hWnd;
	of.lpstrFilter  = STR_FILE_FILTER;
	of.nFilterIndex = 1;
	if(OpenSave == TRUE){
		of.lpstrTitle = STR_TITLE_OPEN;
	}else{
		of.lpstrTitle = STR_TITLE_SAVE;
	}
	of.lpstrFile    = path;
	of.nMaxFile     = MAX_PATH - 1;
	of.lpstrDefExt  = DefExt;
	of.Flags        = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;

	if(OpenSave == TRUE){
		if(GetOpenFileName((LPOPENFILENAME)&of) == FALSE){
			return FALSE;
		}
	}else{
		if(GetSaveFileName((LPOPENFILENAME)&of) == FALSE){
			return FALSE;
		}
	}

	lstrcpy(ret, path);
	return TRUE;
}

//-------------------------------------------
